//+------------------------------------------------------------------+
//|                                 homePIPS Candlestick Pattern.mq4 |
//|                               Copyright  2011, www.homepips.com |
//|                                                 www.homepips.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, www.homepips.com"
#property link      "www.homepips.com"

extern bool ShowAlert = TRUE;
extern color clUp = Lime;
extern color clDown = Red;
#property indicator_chart_window
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectsDeleteAll(0, OBJ_ARROW);

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int bars ;
int start()
  {

   int    counted_bars=IndicatorCounted();
   
  if (bars==counted_bars)
  return;
  
  bars = counted_bars;
//----
   for (int i = counted_bars; i>0; i--)
   {
   IsBullishEngulfing(i);
   IsBearishEngulfing(i);
   IsHammer(i);
   IsHangingMan(i);
   IsDarkCloud(i);
   IsPiercing(i);
   IsMorningStar(i);
   IsEveningStar(i);
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+

bool IsBullishEngulfing(int shift)
{
   if (Open[shift+1]>Close[shift+1]) //Black Candle
   if (Open[shift]<Close[shift]) //White Candle
   if (Close[shift] > Open[shift+1] && Close[shift+1] > Open[shift])
   {
      string name = "Bullish Engulfing BUY!!! - "+DoubleToStr(ObjectsTotal(),0); 
      ObjectCreate(name, OBJ_ARROW, 0, Time[shift], Low[shift]-5*Point); //draw an up arrow
      ObjectSet(name, OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet(name, OBJPROP_ARROWCODE, SYMBOL_ARROWUP);
      ObjectSet(name, OBJPROP_COLOR,clUp); 
      return (true);
   }
   return (false);
}
bool IsBearishEngulfing(int shift)
{
   if (Open[shift+1]<Close[shift+1]) //White Candle
   if (Open[shift]>Close[shift]) //Black Candle
   if (Close[shift] < Open[shift+1] && Close[shift+1] < Open[shift])
   {
      string name = "Bearish Engulfing SELL!!! - "+DoubleToStr(ObjectsTotal(),0); 
      ObjectCreate(name, OBJ_ARROW, 0, Time[shift], High[shift]+15*Point); //draw an up arrow
      ObjectSet(name, OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet(name, OBJPROP_ARROWCODE, SYMBOL_ARROWDOWN);
      ObjectSet(name, OBJPROP_COLOR,clDown); 
      return (true);
   }
   return (false);
}
bool IsHammer(int shift)
{
   double body = Open[shift]-Close[shift];
   double UpShadow, DownShadow;
   if (body<0) body = body * (-1);
   if (Open[shift] > Close[shift])
   {
      DownShadow = Close[shift] - Low[shift];
      UpShadow = High[shift] - Open[shift];
   }
   
   if (Open[shift] < Close[shift])
   {
      DownShadow = Open[shift] - Low[shift];
      UpShadow = High[shift] - Close[shift];
      
   }
   if (Close[shift-1]>Open[shift-1])//urmatoarea lumanare in crestere
   if (DownShadow > body*2 && UpShadow < body/2)
   {
      string name = "Hammer Bullish Reversal BUY!!!- "+DoubleToStr(ObjectsTotal(),0); 
      ObjectCreate(name, OBJ_ARROW, 0, Time[shift], Low[shift]-5*Point); //draw an up arrow
      ObjectSet(name, OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet(name, OBJPROP_ARROWCODE, SYMBOL_ARROWUP);
      ObjectSet(name, OBJPROP_COLOR,clUp); 
      return (true);
   }
   return (false);
}

bool IsHangingMan(int shift)
{
   double body = Open[shift]-Close[shift];
   double UpShadow, DownShadow;
   if (body<0) body = body * (-1);
   if (Open[shift] > Close[shift])
   {
      DownShadow = Close[shift] - Low[shift];
      UpShadow = High[shift] - Open[shift];
   }
   
   if (Open[shift] < Close[shift])
   {
      DownShadow = Open[shift] - Low[shift];
      UpShadow = High[shift] - Close[shift];
      
   }
   if (Close[shift-1]<Open[shift-1])//urmatoarea lumanare in descrestere
   if (UpShadow > body*2 && DownShadow < body/2)
   {
      string name = "Haning man Bearish Reversal SELL!!! - "+DoubleToStr(ObjectsTotal(),0); 
      ObjectCreate(name, OBJ_ARROW, 0, Time[shift], High[shift]+15*Point); //draw an up arrow
      ObjectSet(name, OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet(name, OBJPROP_ARROWCODE, SYMBOL_ARROWDOWN);
      ObjectSet(name, OBJPROP_COLOR,clDown); 
      return (true);
   }
   return (false);
}
bool IsDarkCloud(int shift)
{
   if (Open[shift+2] < Close[shift+2])//lumanarea precedent este descrescatoare
   if (Open[shift+1] > Close[shift+1])//lumanarea precedent este descrescatoare
   if (Open[shift] > Close[shift]) //este tot lumanare de scadere
   if (Open[shift]  > Open[shift+1]) //lumanarea curenta este deschisa cu gap
   if (Close[shift] < Open[shift+2])//se inchide sub valoarea la care s-a deschis ultima lumanare de crestere
   {
      string name = "Dark-Cloud Cover - "+DoubleToStr(ObjectsTotal(),0); 
      ObjectCreate(name, OBJ_ARROW, 0, Time[shift], High[shift]+15*Point); //draw an up arrow
      ObjectSet(name, OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet(name, OBJPROP_ARROWCODE, SYMBOL_ARROWDOWN);
      ObjectSet(name, OBJPROP_COLOR,clDown); 
      return (true);
   }
   return (false);

}
bool IsPiercing(int shift)
{
   if (Open[shift+2] > Close[shift+2])//lumanarea precedent este crescatoare
   if (Open[shift+1] < Close[shift+1])//lumanarea precedent este crescatoare
   if (Open[shift] < Close[shift]) //este tot lumanare de crestere
   if (Open[shift]  > Close[shift+1]) //lumanarea curenta este deschisa cu gap
   if (Close[shift] > Open[shift+2])//se inchide sub valoarea la care s-a deschis ultima lumanare de crestere
   {
      string name = "Piercing Patters Bulish Reversal SELL!!!- "+DoubleToStr(ObjectsTotal(),0); 
      ObjectCreate(name, OBJ_ARROW, 0, Time[shift], Low[shift]-5*Point); //draw an up arrow
      ObjectSet(name, OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet(name, OBJPROP_ARROWCODE, SYMBOL_ARROWUP);
      ObjectSet(name, OBJPROP_COLOR,clUp); 
      return (true);
   }
   return (false);

}
bool IsMorningStar(int shift)
{
bool upCandle = false;
bool isGap = false;
if (Close[shift] > Open[shift])
   upCandle = true;

double body = Open[shift]-Close[shift];
if (body < 0) body = body*(-1);

   if (Open[shift+1] > Close[shift+1])//lumanarea precedent este descrescatoare
   if (Open[shift-1] < Close[shift-1]) //este tot lumanare de crestere
{
   if (upCandle)
   {
      if (Close[shift]  < Close[shift+1]) //lumanarea curenta este deschisa cu gap
      if (Close[shift]  < Open[shift-1]) //lumanarea curenta este deschisa cu gap 
         isGap = true;    
   }
   if (!upCandle)
   {
      if (Open[shift]  < Close[shift+1]) //lumanarea curenta este deschisa cu gap
      if (Open[shift]  < Open[shift-1]) //lumanarea curenta este deschisa cu gap
      isGap = true;
   }
   if (body <= 7*Point && isGap)//body foartemic
   {
      string name = "Morning Star BUY!!! - "+DoubleToStr(ObjectsTotal(),0); 
      ObjectCreate(name, OBJ_ARROW, 0, Time[shift], Low[shift]-5*Point); //draw an up arrow
      ObjectSet(name, OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet(name, OBJPROP_ARROWCODE, SYMBOL_ARROWUP);
      ObjectSet(name, OBJPROP_COLOR,clUp); 
      return (true);
   }
}
   return (false);

}

bool IsEveningStar(int shift)
{
bool upCandle = false;
bool isGap = false;
if (Close[shift] > Open[shift])
   upCandle = true;
   
double body = Open[shift]-Close[shift];
if (body < 0) body = body*(-1);

   if (Open[shift+1] < Close[shift+1])//lumanarea precedent este crescatoare
   if (Open[shift-1] > Close[shift-1]) //este tot lumanare de descrestere
{  
   if (upCandle)
   {
      if (Open[shift]  > Close[shift+1]) //lumanarea curenta este deschisa cu gap
      if (Open[shift]  > Open[shift-1]) //lumanarea curenta este deschisa cu gap 
         isGap = true;    
   }
   if (!upCandle)
   {
      if (Close[shift]  > Close[shift+1]) //lumanarea curenta este deschisa cu gap
      if (Close[shift]  > Open[shift-1]) //lumanarea curenta este deschisa cu gap
      isGap = true;
   }
   if (body <= 7*Point && isGap)//body foartemic
   {
      string name = "Evening Star SELL!!! - "+DoubleToStr(ObjectsTotal(),0); 
      ObjectCreate(name, OBJ_ARROW, 0, Time[shift], High[shift]+15*Point); //draw an up arrow
      ObjectSet(name, OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet(name, OBJPROP_ARROWCODE, SYMBOL_ARROWDOWN);
      ObjectSet(name, OBJPROP_COLOR,clDown); 
      return (true);
   }
}
   return (false);

}